/*
This file is part of mfaktc.
Copyright (C) 2012  George Woltman (woltman@alum.mit.edu)

mfaktc is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

mfaktc is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with mfaktc.  If not, see <http://www.gnu.org/licenses/>.
*/


__device__ static void mulsub_192_M127_initial_special(int192 *res, int192 a, int96 negk, int96 k2m1)
/* res = 0 - a * b (only lower 192 bits of the result), a.d3, a.d4, a.d5 are zero, b is -negk * 2^128 - k2m1 */
{
  asm("{\n\t"
      "mul.lo.u32      %0, %6, %12;\n\t"       /* 0 -= (a.d0 * -k2m1.d0).lo */
      "mul.hi.u32      %1, %6, %12;\n\t"       /* 0 -= (a.d0 * -k2m1.d0).hi */
      "mul.lo.u32      %2, %8, %12;\n\t"       /* 0 -= (a.d2 * -k2m1.d0).lo */

      "mad.lo.cc.u32   %1, %7, %12, %1;\n\t"   /* 0 -= (a.d1 * -k2m1.d0).lo */
      "madc.hi.cc.u32  %2, %7, %12, %2;\n\t"   /* 0 -= (a.d1 * -k2m1.d0).hi */
      "madc.hi.u32     %3, %8, %12, 0;\n\t"    /* 0 -= (a.d2 * -k2m1.d0).hi */

      "mad.lo.cc.u32   %1, %6, %13, %1;\n\t"   /* 0 -= (a.d0 * -k2m1.d1).lo */
      "madc.hi.cc.u32  %2, %6, %13, %2;\n\t"   /* 0 -= (a.d0 * -k2m1.d1).hi */
      "madc.lo.cc.u32  %3, %8, %13, %3;\n\t"   /* 0 -= (a.d2 * -k2m1.d1).lo */
      "madc.hi.u32     %4, %8, %13, 0;\n\t"    /* 0 -= (a.d2 * -k2m1.d1).hi */

      "mad.lo.cc.u32   %2, %7, %13, %2;\n\t"   /* 0 -= (a.d1 * -k2m1.d1).lo */
      "madc.hi.cc.u32  %3, %7, %13, %3;\n\t"   /* 0 -= (a.d1 * -k2m1.d1).hi */
      "madc.lo.cc.u32  %4, %6, %14, %4;\n\t"   /* 0 -= (a.d0 * -negk.d0).lo */
      "madc.lo.u32     %5, %6, %15, 0;\n\t"    /* 0 -= (a.d0 * -negk.d1).lo */
     
      "mad.hi.u32      %5, %6, %14, %5;\n\t"   /* 0 -= (a.d0 * -negk.d0).hi */

      "mad.lo.u32      %5, %7, %14, %5;\n\t"   /* 0 -= (a.d1 * -negk.d0).lo */
      "}"
      : "=r" (res->d0), "=r" (res->d1), "=r" (res->d2), "=r" (res->d3), "=r" (res->d4), "=r" (res->d5)
      : "r" (a.d0), "r" (a.d1), "r" (a.d2), "r" (a.d3), "r" (a.d4), "r" (a.d5),
        "r" (k2m1.d0), "r" (k2m1.d1), "r" (negk.d0), "r" (negk.d1));
}


__device__ static void mulsub_192_M127_special(int192 *res, int384 c, int192 a, int96 negk, int96 k2m1)
/* res = c - a * b (only lower 192 bits of the result), b is -negk * 2^128 - k2m1 */
{
  asm("{\n\t"
      "mad.lo.cc.u32   %0, %6, %12, %16;\n\t"  /* c -= (a.d0 * -k2m1.d0).lo */
      "madc.lo.cc.u32  %1, %6, %13, %17;\n\t"  /* c -= (a.d0 * -k2m1.d1).lo */
      "madc.lo.cc.u32  %2, %8, %12, %18;\n\t"  /* c -= (a.d2 * -k2m1.d0).lo */
      "madc.lo.cc.u32  %3, %8, %13, %19;\n\t"  /* c -= (a.d2 * -k2m1.d1).lo */
      "madc.lo.cc.u32  %4, %10, %12, %20;\n\t" /* c -= (a.d4 * -k2m1.d0).lo */
      "madc.lo.u32     %5, %10, %13, %21;\n\t" /* c -= (a.d4 * -k2m1.d1).lo */

      "mad.hi.cc.u32   %1, %6, %12, %1;\n\t"   /* c -= (a.d0 * -k2m1.d0).hi */
      "madc.hi.cc.u32  %2, %6, %13, %2;\n\t"   /* c -= (a.d0 * -k2m1.d1).hi */
      "madc.hi.cc.u32  %3, %8, %12, %3;\n\t"   /* c -= (a.d2 * -k2m1.d0).hi */
      "madc.hi.cc.u32  %4, %8, %13, %4;\n\t"   /* c -= (a.d2 * -k2m1.d1).hi */
      "madc.hi.u32     %5, %10, %12, %5;\n\t"  /* c -= (a.d4 * -k2m1.d0).hi */

      "mad.lo.cc.u32   %1, %7, %12, %1;\n\t"   /* c -= (a.d1 * -k2m1.d0).lo */
      "madc.lo.cc.u32  %2, %7, %13, %2;\n\t"   /* c -= (a.d1 * -k2m1.d1).lo */
      "madc.lo.cc.u32  %3, %9, %12, %3;\n\t"   /* c -= (a.d3 * -k2m1.d0).lo */
      "madc.lo.cc.u32  %4, %9, %13, %4;\n\t"   /* c -= (a.d3 * -k2m1.d1).lo */
      "madc.lo.u32     %5, %11, %12, %5;\n\t"  /* c -= (a.d5 * -k2m1.d0).lo */

      "mad.hi.cc.u32   %2, %7, %12, %2;\n\t"   /* c -= (a.d1 * -k2m1.d0).hi */
      "madc.hi.cc.u32  %3, %7, %13, %3;\n\t"   /* c -= (a.d1 * -k2m1.d1).hi */
      "madc.hi.cc.u32  %4, %9, %12, %4;\n\t"   /* c -= (a.d3 * -k2m1.d0).hi */
      "madc.hi.u32     %5, %9, %13, %5;\n\t"   /* c -= (a.d3 * -k2m1.d1).hi */

      "mad.lo.cc.u32   %4, %6, %14, %4;\n\t"   /* c -= (a.d0 * -negk.d0).lo */
      "madc.lo.u32     %5, %6, %15, %5;\n\t"   /* c -= (a.d0 * -negk.d1).lo */

      "mad.hi.u32      %5, %6, %14, %5;\n\t"   /* c -= (a.d0 * -negk.d0).hi */

      "mad.lo.u32      %5, %7, %14, %5;\n\t"   /* c -= (a.d1 * -negk.d0).lo */
      "}"
      : "=r" (res->d0), "=r" (res->d1), "=r" (res->d2), "=r" (res->d3), "=r" (res->d4), "=r" (res->d5)
      : "r" (a.d0), "r" (a.d1), "r" (a.d2), "r" (a.d3), "r" (a.d4), "r" (a.d5),
        "r" (k2m1.d0), "r" (k2m1.d1), "r" (negk.d0), "r" (negk.d1),
        "r" (c.d0), "r" (c.d1), "r" (c.d2), "r" (c.d3), "r" (c.d4), "r" (c.d5));
}

//
// Kernel to factor MM127, works on f between 161 and 183 bits inclusive (k = 2^33 to k = 2^55)
//

__global__ void
__launch_bounds__(THREADS_PER_BLOCK, KERNEL_MIN_BLOCKS) mfaktc_barrett183_M127gs(int96 k_base, unsigned int *bit_array, unsigned int bits_to_process, unsigned int *RES, unsigned int bits_max)
{
  int i, words_per_thread, sieve_word, k_bit_base, total_bit_count;
  int192 f, finalrem;
  __shared__ volatile unsigned short bitcount[256];	// Each thread of our block puts bit-counts here
  extern __shared__ unsigned short smem[];		// Write bits to test here.  Launching program must estimate
							// how much shared memory to allocate based on number of primes sieved.

  // Get pointer to section of the bit_array this thread is processing.

  words_per_thread = bits_to_process / 8192;
  bit_array += blockIdx.x * bits_to_process / 32 + threadIdx.x * words_per_thread;

// Count number of bits set in this thread's word(s) from the bit_array

  bitcount[threadIdx.x] = 0;
  for (i = 0; i < words_per_thread; i++)
    bitcount[threadIdx.x] += ___popcnt(bit_array[i]);

// Create total count of bits set in block up to and including this threads popcnt.
// Kudos to Rocke Verser for the population counting code.
// CAUTION:  Following requires 256 threads per block

  // First five tallies remain within one warp.  Should be in lock-step.
  if (threadIdx.x & 1)        // If we are running on any thread 0bxxxxxxx1, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[threadIdx.x - 1];

  if (threadIdx.x & 2)        // If we are running on any thread 0bxxxxxx1x, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 2) | 1];

  if (threadIdx.x & 4)        // If we are running on any thread 0bxxxxx1xx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 4) | 3];

  if (threadIdx.x & 8)        // If we are running on any thread 0bxxxx1xxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 8) | 7];

  if (threadIdx.x & 16)       // If we are running on any thread 0bxxx1xxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 16) | 15];

  // Further tallies are across warps.  Must synchronize
  __syncthreads();
  if (threadIdx.x  & 32)      // If we are running on any thread 0bxx1xxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 32) | 31];

  __syncthreads();
  if (threadIdx.x & 64)       // If we are running on any thread 0bx1xxxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 64) | 63];

  __syncthreads();
  if (threadIdx.x & 128)       // If we are running on any thread 0b1xxxxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[127];

  // At this point, bitcount[...] contains the total number of bits for the indexed
  // thread plus all lower-numbered threads.  I.e., bitcount[255] is the total count.

  __syncthreads();
  total_bit_count = bitcount[255];

//POSSIBLE OPTIMIZATION - bitcounts and smem could use the same memory space if we'd read bitcount into a register
// and sync threads before doing any writes to smem.

//POSSIBLE SANITY CHECK -- is there any way to test if total_bit_count exceeds the amount of shared memory allocated?

// Loop til this thread's section of the bit array is finished.

  sieve_word = *bit_array;
  k_bit_base = threadIdx.x * words_per_thread * 32;
  for (i = total_bit_count - bitcount[threadIdx.x]; ; i++) {
    int bit_to_test;

// Make sure we have a non-zero sieve word

    while (sieve_word == 0) {
      if (--words_per_thread == 0) break;
      sieve_word = *++bit_array;
      k_bit_base += 32;
    }

// Check if this thread has processed all its set bits

    if (sieve_word == 0) break;

// Find a bit to test in the sieve word

    bit_to_test = 31 - ___clz (sieve_word);
    sieve_word &= ~(1 << bit_to_test);

// Copy the k value to the shared memory array

    smem[i] = k_bit_base + bit_to_test;
  }

  __syncthreads();

// Here, all warps in our block have placed their candidates in shared memory.
// Now we can start TFing candidates.

// Pre-init values used to compute factor

  // Compute base k value
  k_base.d0 = __add_cc (k_base.d0, __umul32  (blockIdx.x * bits_to_process, NUM_CLASSES));
  k_base.d1 = __addc   (k_base.d1, __umul32hi(blockIdx.x * bits_to_process, NUM_CLASSES)); /* k values are limited to 64 bits */

// Loop til the k values written to shared memory are exhausted

  for (i = threadIdx.x; i < total_bit_count; i += THREADS_PER_BLOCK) {
    int96 k, k2m1;
    int192 a, u, tmp192;
    int384 b, tmp384;
    float ff;
    int k_delta, shifter;

// Get the (k - k_base) value to test

    k_delta = smem[i];

// Compute f = 2 * k * M127 + 1 = k * 2^128 - 2k + 1

    k.d0 = __add_cc (k_base.d0, k_delta * NUM_CLASSES);	// k
    k.d1 = __addc   (k_base.d1, 0);

    k2m1.d0 = __add_cc (k.d0, k.d0);	// 2k-1
    k2m1.d1 = __addc   (k.d1, k.d1);
    k2m1.d0 = __sub_cc (k2m1.d0, 1);
    k2m1.d1 = __subc   (k2m1.d1, 0);

    f.d0 = __sub_cc (0, k2m1.d0);	// 1-2k
    f.d1 = __subc   (0, k2m1.d1);
    f.d2 = 0xFFFFFFFF;
    f.d3 = 0xFFFFFFFF;
    f.d4 = __sub_cc (k.d0, 1);		// k * 2^128 - propagate carry
    f.d5 = __subc   (k.d1, 0);

/*
ff = f as float
Precalculated here since it is the same for all steps in the following loop */
    ff= __uint2float_rn(f.d5);
    ff= ff * 4294967296.0f + __uint2float_rn(f.d4);
    ff=__int_as_float(0x3f7ffffb) / ff;			// just a little bit below 1.0f so we always underestimate the quotient

    tmp384.d11 = 1 << (bits_max - 1);			// tmp384 = 2^(191 + bits_in_f)
    tmp384.d10 = 0; tmp384.d9 = 0; tmp384.d8 = 0; tmp384.d7 = 0; tmp384.d6 = 0;
    tmp384.d5 = 0; tmp384.d4 = 0; tmp384.d3 = 0; tmp384.d2 = 0; tmp384.d1 = 0; tmp384.d0 = 0;

    // Could write optimized div_384_192 with so many tmp384 elements known to be zero
    div_384_192(&u,tmp384,f,ff);			// u = floor(2^(191 + bits_in_f) / f), giving 192 bits of precision, requires f >= 161 bits

							// b_preinit = 2^256
							// Let a = b_preinit / 2 ^ (bits_in_f - 1)
							// tmp192 = a * u / 2^192
							//        = (b_preinit / 2 ^ (bits_in_f - 1)) * (2 ^ (191 + bits_in_f) / f) / 2^192    (ignore the floor functions for now)
							// which if we do the math simplifies to the quotient: b_preinit / f
    tmp192.d0 = (u.d3 >> (bits_max - 1)) + (u.d4 << (32 - (bits_max - 1)));
    tmp192.d1 = (u.d4 >> (bits_max - 1)) + (u.d5 << (32 - (bits_max - 1)));
    tmp192.d2 = (u.d5 >> (bits_max - 1));

    k.d0 = __sub_cc (0, k.d0);				// Negate k so that the mulsub macros can use multiply-accumulate instructions
    k.d1 = __subc   (0, k.d1);

    mulsub_192_M127_initial_special(&a, tmp192, k, k2m1); // Compute the remainder: b_preinit - quotient * f, we only compute the low 192-bits here

    for (shifter = 0; shifter < 119; shifter++)
    {
							// On input a is at most 186.700 bits (see end of this loop)

      square_192_384(&b, a);				// b = a^2, b is at most 373.400 bits

      a.d0 = (b.d5 >> (bits_max - 1)) + (b.d6 << (32 - (bits_max - 1))); // a = b / (2 ^ (bits_in_f - 1)), a is at most 191.400 bits
      a.d1 = (b.d6 >> (bits_max - 1)) + (b.d7 << (32 - (bits_max - 1)));
      a.d2 = (b.d7 >> (bits_max - 1)) + (b.d8 << (32 - (bits_max - 1)));
      a.d3 = (b.d8 >> (bits_max - 1)) + (b.d9 << (32 - (bits_max - 1)));
      a.d4 = (b.d9 >> (bits_max - 1)) + (b.d10 << (32 - (bits_max - 1)));
      a.d5 = (b.d10 >> (bits_max - 1)) + (b.d11 << (32 - (bits_max - 1)));

      mul_192_384_no_low6(&tmp192, a, u);		// tmp192 = (b / 2 ^ (bits_in_f - 1)) * (2 ^ (191 + bits_in_f) / f) / 2^192  (ignore the floor functions for now)
							// which if we do the math simplifies to the quotient: b / f

							// The quotient is off by at most 12.  A full mul_192_384 would add 11 partial results
							// into tmp384.d5 which could have generated 10 carries into tmp384.d6.
							// Also, since u was generated with the floor function, it could be low by up to
							// almost 1.  If we account for this a value up to a.d5 could have been added into
							// tmp384.d5 possibly generating a carry.  Similarly, a was generated by a floor
							// function, and could thus be low by almost 1.  If we account for this a value up
							// to u.d5 could have been added into tmp384.d5 possibly generating a carry.
							// A grand total of up to 12 carries lost.

      mulsub_192_M127_special(&a, b, tmp192, k, k2m1);	// Compute the remainder: b - quotient * f, we only compute the low 192-bits here

							// Since the quotient was up to 12 too small, the remainder has a maximum value of 13*f,
							// or 183 bits + log2 (13) bits, which is 186.700 bits.  In theory, this kernel can handle
							// f values up to 2^183.300.
    }

    mod_simple_192(&finalrem, a, f, ff);		// Adjustment.  The code above may produce an a that is too large by up to 12 times f.

#if 0
    if(cmp_ge_192(finalrem,f))
    {
      printf("EEEEEK, final finalrem is >= f\n");
    }
if (blockIdx.x == 0 && threadIdx.x == 4){
mul_192_384_no_low6(&tmp192,u,f);
printf ("bits_in_f: %d\r\n", 352 + (bits_max - 1) - 191);
printf ("    f: %08X%08X%08X%08X%08X%08X\r\n", f.d5, f.d4, f.d3, f.d2, f.d1, f.d0);
printf ("u    : %X %X %X %X %X %X\r\n", u.d5, u.d4, u.d3, u.d2, u.d1, u.d0);
printf ("u * f: %X %X %X %X %X %X\r\n", tmp192.d5, tmp192.d4, tmp192.d3, tmp192.d2, tmp192.d1, tmp192.d0);
printf ("  rem: %08X%08X%08X%08X%08X%08X\r\n", finalrem.d5, finalrem.d4, finalrem.d3, finalrem.d2, finalrem.d1, finalrem.d0);
}
#endif

/* check if we found a factor and write the factor to RES[] */

    if(finalrem.d0 == 2 && (finalrem.d5 | finalrem.d4 | finalrem.d3 | finalrem.d2 | finalrem.d1) == 0)
    {
      int index=atomicInc(&RES[0],10000);
      if(index<10)				/* limit to 10 factors per class */
      {
        RES[index*6 + 1]=f.d5;
	RES[index*6 + 2]=f.d4;
	RES[index*6 + 3]=0xFFFFFFFF;
	RES[index*6 + 4]=0xFFFFFFFF;
	RES[index*6 + 5]=f.d1;
	RES[index*6 + 6]=f.d0;
      }
    }
  }

/* finally write occasional result for validation by C code */

  if(blockIdx.x == 0 && threadIdx.x == 0)
  {
    RES[84]=f.d5;
    RES[85]=f.d4;
    RES[86]=0xFFFFFFFF;
    RES[87]=0xFFFFFFFF;
    RES[88]=f.d1;
    RES[89]=f.d0;
    RES[94]=finalrem.d5;
    RES[95]=finalrem.d4;
    RES[96]=finalrem.d3;
    RES[97]=finalrem.d2;
    RES[98]=finalrem.d1;
    RES[99]=finalrem.d0;
  }
}


//
// Kernel to factor MM127, works on f between 184 and 185 bits inclusive (k = 2^56 to k = 2^57)
//

__global__ void
__launch_bounds__(THREADS_PER_BLOCK, KERNEL_MIN_BLOCKS) mfaktc_barrett185_M127gs(int96 k_base, unsigned int *bit_array, unsigned int bits_to_process, unsigned int *RES, unsigned int bits_max)
{
  int i, words_per_thread, sieve_word, k_bit_base, total_bit_count;
  int192 f, a;
  __shared__ volatile unsigned short bitcount[256];	// Each thread of our block puts bit-counts here
  extern __shared__ unsigned short smem[];		// Write bits to test here.  Launching program must estimate
							// how much shared memory to allocate based on number of primes sieved.

  // Get pointer to section of the bit_array this thread is processing.

  words_per_thread = bits_to_process / 8192;
  bit_array += blockIdx.x * bits_to_process / 32 + threadIdx.x * words_per_thread;

// Count number of bits set in this thread's word(s) from the bit_array

  bitcount[threadIdx.x] = 0;
  for (i = 0; i < words_per_thread; i++)
    bitcount[threadIdx.x] += ___popcnt(bit_array[i]);

// Create total count of bits set in block up to and including this threads popcnt.
// Kudos to Rocke Verser for the population counting code.
// CAUTION:  Following requires 256 threads per block

  // First five tallies remain within one warp.  Should be in lock-step.
  if (threadIdx.x & 1)        // If we are running on any thread 0bxxxxxxx1, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[threadIdx.x - 1];

  if (threadIdx.x & 2)        // If we are running on any thread 0bxxxxxx1x, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 2) | 1];

  if (threadIdx.x & 4)        // If we are running on any thread 0bxxxxx1xx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 4) | 3];

  if (threadIdx.x & 8)        // If we are running on any thread 0bxxxx1xxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 8) | 7];

  if (threadIdx.x & 16)       // If we are running on any thread 0bxxx1xxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 16) | 15];

  // Further tallies are across warps.  Must synchronize
  __syncthreads();
  if (threadIdx.x  & 32)      // If we are running on any thread 0bxx1xxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 32) | 31];

  __syncthreads();
  if (threadIdx.x & 64)       // If we are running on any thread 0bx1xxxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 64) | 63];

  __syncthreads();
  if (threadIdx.x & 128)       // If we are running on any thread 0b1xxxxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[127];

  // At this point, bitcount[...] contains the total number of bits for the indexed
  // thread plus all lower-numbered threads.  I.e., bitcount[255] is the total count.

  __syncthreads();
  total_bit_count = bitcount[255];

//POSSIBLE OPTIMIZATION - bitcounts and smem could use the same memory space if we'd read bitcount into a register
// and sync threads before doing any writes to smem.

//POSSIBLE SANITY CHECK -- is there any way to test if total_bit_count exceeds the amount of shared memory allocated?

// Loop til this thread's section of the bit array is finished.

  sieve_word = *bit_array;
  k_bit_base = threadIdx.x * words_per_thread * 32;
  for (i = total_bit_count - bitcount[threadIdx.x]; ; i++) {
    int bit_to_test;

// Make sure we have a non-zero sieve word

    while (sieve_word == 0) {
      if (--words_per_thread == 0) break;
      sieve_word = *++bit_array;
      k_bit_base += 32;
    }

// Check if this thread has processed all its set bits

    if (sieve_word == 0) break;

// Find a bit to test in the sieve word

    bit_to_test = 31 - ___clz (sieve_word);
    sieve_word &= ~(1 << bit_to_test);

// Copy the k value to the shared memory array

    smem[i] = k_bit_base + bit_to_test;
  }

  __syncthreads();

// Here, all warps in our block have placed their candidates in shared memory.
// Now we can start TFing candidates.

// Pre-init values used to compute factor

  // Compute base k value
  k_base.d0 = __add_cc (k_base.d0, __umul32  (blockIdx.x * bits_to_process, NUM_CLASSES));
  k_base.d1 = __addc   (k_base.d1, __umul32hi(blockIdx.x * bits_to_process, NUM_CLASSES)); /* k values are limited to 64 bits */

// Loop til the k values written to shared memory are exhausted

  for (i = threadIdx.x; i < total_bit_count; i += THREADS_PER_BLOCK) {
    int96 k, k2m1;
    int192 u, tmp192;
    int384 b, tmp384;
    float ff;
    int k_delta, shifter;

// Get the (k - k_base) value to test

    k_delta = smem[i];

// Compute f = 2 * k * M127 + 1 = k * 2^128 - 2k + 1

    k.d0 = __add_cc (k_base.d0, k_delta * NUM_CLASSES);	// k
    k.d1 = __addc   (k_base.d1, 0);

    k2m1.d0 = __add_cc (k.d0, k.d0);	// 2k-1
    k2m1.d1 = __addc   (k.d1, k.d1);
    k2m1.d0 = __sub_cc (k2m1.d0, 1);
    k2m1.d1 = __subc   (k2m1.d1, 0);

    f.d0 = __sub_cc (0, k2m1.d0);	// 1-2k
    f.d1 = __subc   (0, k2m1.d1);
    f.d2 = 0xFFFFFFFF;
    f.d3 = 0xFFFFFFFF;
    f.d4 = __sub_cc (k.d0, 1);		// k * 2^128 - propagate carry
    f.d5 = __subc   (k.d1, 0);

/*
ff = f as float
Precalculated here since it is the same for all steps in the following loop */
    ff= __uint2float_rn(f.d5);
    ff= ff * 4294967296.0f + __uint2float_rn(f.d4);
    ff=__int_as_float(0x3f7ffffb) / ff;			// just a little bit below 1.0f so we always underestimate the quotient

    tmp384.d11 = 1 << (bits_max - 1);			// tmp384 = 2^(191 + bits_in_f)
    tmp384.d10 = 0; tmp384.d9 = 0; tmp384.d8 = 0; tmp384.d7 = 0; tmp384.d6 = 0;
    tmp384.d5 = 0; tmp384.d4 = 0; tmp384.d3 = 0; tmp384.d2 = 0; tmp384.d1 = 0; tmp384.d0 = 0;

    // Could write optimized div_384_192 with so many tmp384 elements known to be zero
    div_384_192(&u,tmp384,f,ff);			// u = floor(2^(191 + bits_in_f) / f), giving 192 bits of precision

							// b_preinit = 2^256
							// Let a = b_preinit / 2 ^ (bits_in_f - 1)
							// tmp192 = a * u / 2^192
							//        = (b_preinit / 2 ^ (bits_in_f - 1)) * (2 ^ (191 + bits_in_f) / f) / 2^192   (ignore the floor functions for now)
							// which if we do the math simplifies to the quotient: b_preinit / f
    tmp192.d0 = (u.d3 >> (bits_max - 1)) + (u.d4 << (32 - (bits_max - 1)));
    tmp192.d1 = (u.d4 >> (bits_max - 1)) + (u.d5 << (32 - (bits_max - 1)));
    tmp192.d2 = (u.d5 >> (bits_max - 1));

    k.d0 = __sub_cc (0, k.d0);				// Negate k so that the mulsub macros can use multiply-accumulate instructions
    k.d1 = __subc   (0, k.d1);

    mulsub_192_M127_initial_special(&a, tmp192, k, k2m1); // Compute the remainder: b_preinit - quotient * f, we only compute the low 192-bits here

    for (shifter = 0; shifter < 119; shifter++)
    {
							// On input a is at most 185.807 bits (see end of this loop)

      square_192_384(&b, a);				// b = a^2, b is at most 371.614 bits

      a.d0 = (b.d5 >> (bits_max - 5)) + (b.d6 << (32 - (bits_max - 5))); // a = b / (2 ^ (bits_in_f - 5)), a is at most 191.614 bits
      a.d1 = (b.d6 >> (bits_max - 5)) + (b.d7 << (32 - (bits_max - 5)));
      a.d2 = (b.d7 >> (bits_max - 5)) + (b.d8 << (32 - (bits_max - 5)));
      a.d3 = (b.d8 >> (bits_max - 5)) + (b.d9 << (32 - (bits_max - 5)));
      a.d4 = (b.d9 >> (bits_max - 5)) + (b.d10 << (32 - (bits_max - 5)));
      a.d5 = (b.d10 >> (bits_max - 5)) + (b.d11 << (32 - (bits_max - 5)));

      mul_192_384_no_low6(&tmp192, a, u);		// tmp192 = (b / 2 ^ (bits_in_f - 5)) * (2 ^ (191 + bits_in_f) / f) / 2^192  (ignore the floor functions for now)
      tmp192.d0 = (tmp192.d0 >> 4) + (tmp192.d1 << 28);	// tmp192 /= 2^4, which if we do the math simplifies to the quotient: b / f
      tmp192.d1 = (tmp192.d1 >> 4) + (tmp192.d2 << 28);
      tmp192.d2 = (tmp192.d2 >> 4) + (tmp192.d3 << 28);
      tmp192.d3 = (tmp192.d3 >> 4) + (tmp192.d4 << 28);
      tmp192.d4 = (tmp192.d4 >> 4) + (tmp192.d5 << 28);
      tmp192.d5 = (tmp192.d5 >> 4);
							// The quotient is off by at most 12/16.  A full mul_192_384 would add 11 partial results
							// into tmp384.d5 which could have generated 10 carries into tmp384.d6.
							// Also, since u was generated with the floor function, it could be low by up to
							// almost 1.  If we account for this a value up to a.d5 could have been added into
							// tmp384.d5 possibly generating a carry.  Similarly, a was generated by a floor
							// function, and could thus be low by almost 1.  If we account for this a value up
							// to u.d5 could have been added into tmp384.d5 possibly generating a carry.
							// A grand total of up to 12 carries lost.  However, we calculated an extra 4 bits of
							// precision in mul_192_384_no_low6 the shifted quotient is off by at most 12/16.

      mulsub_192_M127_special(&a, b, tmp192, k, k2m1);	// Compute the remainder: b - quotient * f, we only compute the low 192-bits here

							// Since the quotient was up to 12/16 too small, the remainder has a maximum value of (1+12/16)*f,
							// or 185 bits + log2 (1+12/16) bits, which is 185.807 bits.  In theory, this kernel can handle
							// f values up to 2^185.193.
    }

    if(cmp_ge_192(a,f))					// final adjustment in case a >= f
    {
      sub_192(&a, a, f);
    }

#if 0
    if(cmp_ge_192(a,f))
    {
      printf("EEEEEK, final a is >= f\n");
    }
if (blockIdx.x == 12 && threadIdx.x == 4){
mul_192_384_no_low6(&tmp192,u,f);
printf ("bits_in_f: %d\r\n", 352 + (bits_max - 1) - 191);
printf ("    f: %08X%08X%08X%08X%08X%08X\r\n", f.d5, f.d4, f.d3, f.d2, f.d1, f.d0);
printf ("u    : %X %X %X %X %X %X\r\n", u.d5, u.d4, u.d3, u.d2, u.d1, u.d0);
printf ("u * f: %X %X %X %X %X %X\r\n", tmp192.d5, tmp192.d4, tmp192.d3, tmp192.d2, tmp192.d1, tmp192.d0);
printf ("    a: %08X%08X%08X%08X%08X%08X\r\n", a.d5, a.d4, a.d3, a.d2, a.d1, a.d0);
}
#endif

/* check if we found a factor and write the factor to RES[] */

    if(a.d0 == 2 && (a.d5 | a.d4 | a.d3 | a.d2 | a.d1) == 0)
    {
      int index=atomicInc(&RES[0],10000);
      if(index<10)				/* limit to 10 factors per class */
      {
        RES[index*6 + 1]=f.d5;
	RES[index*6 + 2]=f.d4;
	RES[index*6 + 3]=0xFFFFFFFF;
	RES[index*6 + 4]=0xFFFFFFFF;
	RES[index*6 + 5]=f.d1;
	RES[index*6 + 6]=f.d0;
      }
    }
  }

/* finally write occasional result for validation by C code */

  if(blockIdx.x == 0 && threadIdx.x == 0)
  {
    RES[84]=f.d5;
    RES[85]=f.d4;
    RES[86]=0xFFFFFFFF;
    RES[87]=0xFFFFFFFF;
    RES[88]=f.d1;
    RES[89]=f.d0;
    RES[94]=a.d5;
    RES[95]=a.d4;
    RES[96]=a.d3;
    RES[97]=a.d2;
    RES[98]=a.d1;
    RES[99]=a.d0;
  }
}


//
// Kernel to factor MM127, works on f between 186 and 188 bits inclusive (k = 2^58 to k = 2^60)
//

__global__ void
__launch_bounds__(THREADS_PER_BLOCK, KERNEL_MIN_BLOCKS) mfaktc_barrett188_M127gs(int96 k_base, unsigned int *bit_array, unsigned int bits_to_process, unsigned int *RES, unsigned int bits_max)
{
  int i, words_per_thread, sieve_word, k_bit_base, total_bit_count;
  int192 f, a;
  __shared__ volatile unsigned short bitcount[256];	// Each thread of our block puts bit-counts here
  extern __shared__ unsigned short smem[];		// Write bits to test here.  Launching program must estimate
							// how much shared memory to allocate based on number of primes sieved.

  // Get pointer to section of the bit_array this thread is processing.

  words_per_thread = bits_to_process / 8192;
  bit_array += blockIdx.x * bits_to_process / 32 + threadIdx.x * words_per_thread;

// Count number of bits set in this thread's word(s) from the bit_array

  bitcount[threadIdx.x] = 0;
  for (i = 0; i < words_per_thread; i++)
    bitcount[threadIdx.x] += ___popcnt(bit_array[i]);

// Create total count of bits set in block up to and including this threads popcnt.
// Kudos to Rocke Verser for the population counting code.
// CAUTION:  Following requires 256 threads per block

  // First five tallies remain within one warp.  Should be in lock-step.
  if (threadIdx.x & 1)        // If we are running on any thread 0bxxxxxxx1, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[threadIdx.x - 1];

  if (threadIdx.x & 2)        // If we are running on any thread 0bxxxxxx1x, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 2) | 1];

  if (threadIdx.x & 4)        // If we are running on any thread 0bxxxxx1xx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 4) | 3];

  if (threadIdx.x & 8)        // If we are running on any thread 0bxxxx1xxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 8) | 7];

  if (threadIdx.x & 16)       // If we are running on any thread 0bxxx1xxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 16) | 15];

  // Further tallies are across warps.  Must synchronize
  __syncthreads();
  if (threadIdx.x  & 32)      // If we are running on any thread 0bxx1xxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 32) | 31];

  __syncthreads();
  if (threadIdx.x & 64)       // If we are running on any thread 0bx1xxxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 64) | 63];

  __syncthreads();
  if (threadIdx.x & 128)       // If we are running on any thread 0b1xxxxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[127];

  // At this point, bitcount[...] contains the total number of bits for the indexed
  // thread plus all lower-numbered threads.  I.e., bitcount[255] is the total count.

  __syncthreads();
  total_bit_count = bitcount[255];

//POSSIBLE OPTIMIZATION - bitcounts and smem could use the same memory space if we'd read bitcount into a register
// and sync threads before doing any writes to smem.

//POSSIBLE SANITY CHECK -- is there any way to test if total_bit_count exceeds the amount of shared memory allocated?

// Loop til this thread's section of the bit array is finished.

  sieve_word = *bit_array;
  k_bit_base = threadIdx.x * words_per_thread * 32;
  for (i = total_bit_count - bitcount[threadIdx.x]; ; i++) {
    int bit_to_test;

// Make sure we have a non-zero sieve word

    while (sieve_word == 0) {
      if (--words_per_thread == 0) break;
      sieve_word = *++bit_array;
      k_bit_base += 32;
    }

// Check if this thread has processed all its set bits

    if (sieve_word == 0) break;

// Find a bit to test in the sieve word

    bit_to_test = 31 - ___clz (sieve_word);
    sieve_word &= ~(1 << bit_to_test);

// Copy the k value to the shared memory array

    smem[i] = k_bit_base + bit_to_test;
  }

  __syncthreads();

// Here, all warps in our block have placed their candidates in shared memory.
// Now we can start TFing candidates.

// Pre-init values used to compute factor

  // Compute base k value
  k_base.d0 = __add_cc (k_base.d0, __umul32  (blockIdx.x * bits_to_process, NUM_CLASSES));
  k_base.d1 = __addc   (k_base.d1, __umul32hi(blockIdx.x * bits_to_process, NUM_CLASSES)); /* k values are limited to 64 bits */

// Loop til the k values written to shared memory are exhausted

  for (i = threadIdx.x; i < total_bit_count; i += THREADS_PER_BLOCK) {
    int96 k, k2m1;
    int192 u, tmp192;
    int384 b, tmp384;
    float ff;
    int k_delta, shifter;

// Get the (k - k_base) value to test

    k_delta = smem[i];

// Compute f = 2 * k * M127 + 1 = k * 2^128 - 2k + 1

    k.d0 = __add_cc (k_base.d0, k_delta * NUM_CLASSES);	// k
    k.d1 = __addc   (k_base.d1, 0);

    k2m1.d0 = __add_cc (k.d0, k.d0);	// 2k-1
    k2m1.d1 = __addc   (k.d1, k.d1);
    k2m1.d0 = __sub_cc (k2m1.d0, 1);
    k2m1.d1 = __subc   (k2m1.d1, 0);

    f.d0 = __sub_cc (0, k2m1.d0);	// 1-2k
    f.d1 = __subc   (0, k2m1.d1);
    f.d2 = 0xFFFFFFFF;
    f.d3 = 0xFFFFFFFF;
    f.d4 = __sub_cc (k.d0, 1);		// k * 2^128 - propagate carry
    f.d5 = __subc   (k.d1, 0);

/*
ff = f as float
Precalculated here since it is the same for all steps in the following loop */
    ff= __uint2float_rn(f.d5);
    ff= ff * 4294967296.0f + __uint2float_rn(f.d4);
    ff=__int_as_float(0x3f7ffffb) / ff;			// just a little bit below 1.0f so we always underestimate the quotient

    tmp384.d11 = 1 << (bits_max - 1);			// tmp384 = 2^(191 + bits_in_f)
    tmp384.d10 = 0; tmp384.d9 = 0; tmp384.d8 = 0; tmp384.d7 = 0; tmp384.d6 = 0;
    tmp384.d5 = 0; tmp384.d4 = 0; tmp384.d3 = 0; tmp384.d2 = 0; tmp384.d1 = 0; tmp384.d0 = 0;

    // Could write optimized div_384_192 with so many tmp384 elements known to be zero
    div_384_192(&u,tmp384,f,ff);			// u = floor(2^(192 + bits_in_f) / f), giving 192 bits of precision

							// b_preinit = 2^256
							// Let a = b_preinit / 2 ^ (bits_in_f - 1)
							// tmp192 = a * u / 2^192
							//        = (b_preinit / 2 ^ (bits_in_f - 1)) * (2 ^ (191 + bits_in_f) / f) / 2^192   (ignore the floor functions for now)
							// which if we do the math simplifies to the quotient: b_preinit / f
    tmp192.d0 = (u.d3 >> (bits_max - 1)) + (u.d4 << (32 - (bits_max - 1)));
    tmp192.d1 = (u.d4 >> (bits_max - 1)) + (u.d5 << (32 - (bits_max - 1)));
    tmp192.d2 = (u.d5 >> (bits_max - 1));

    k.d0 = __sub_cc (0, k.d0);				// Negate k so that the mulsub macros can use multiply-accumulate instructions
    k.d1 = __subc   (0, k.d1);

    mulsub_192_M127_initial_special(&a, tmp192, k, k2m1); // Compute the remainder: b_preinit - quotient * f, we only compute the low 192-bits here

    for (shifter = 0; shifter < 119; shifter++)
    {
							// On input a is at most 188 bits (see end of this loop)

      square_192_384(&b, a);				// b = a^2, b is at most 376 bits

      a.d0 = (b.d5 >> (bits_max - 1)) + (b.d6 << (32 - (bits_max - 1))); // a = b / (2 ^ (bits_in_f - 1)), a is at most 189 bits
      a.d1 = (b.d6 >> (bits_max - 1)) + (b.d7 << (32 - (bits_max - 1)));
      a.d2 = (b.d7 >> (bits_max - 1)) + (b.d8 << (32 - (bits_max - 1)));
      a.d3 = (b.d8 >> (bits_max - 1)) + (b.d9 << (32 - (bits_max - 1)));
      a.d4 = (b.d9 >> (bits_max - 1)) + (b.d10 << (32 - (bits_max - 1)));
      a.d5 = (b.d10 >> (bits_max - 1)) + (b.d11 << (32 - (bits_max - 1)));

      mul_192_384_no_low6(&tmp192, a, u);		// tmp192 = (b / 2 ^ (bits_in_f - 1)) * (2 ^ (191 + bits_in_f) / f) / 2^192  (ignore the floor functions for now)
							// which if we do the math simplifies to the quotient: b / f

							// The quotient is off by at most 12.  A full mul_192_384 would add 11 partial results
							// into tmp384.d5 which could have generated 10 carries into tmp384.d6.
							// Also, since u was generated with the floor function, it could be low by up to
							// almost 1.  If we account for this a value up to a.d5 could have been added into
							// tmp384.d5 possibly generating a carry.  Similarly, a was generated by a floor
							// function, and could thus be low by almost 1.  If we account for this a value up
							// to u.d5 could have been added into tmp384.d5 possibly generating a carry.
							// A grand total of up to 12 carries lost.

      mulsub_192_M127_special(&a, b, tmp192, k, k2m1);	// Compute the remainder: b - quotient * f, we only compute the low 192-bits here

							// Since the quotient was up to 12 too small, the remainder has a maximum value of 13*f,
							// or 188 bits + log2 (13) bits, which is 191.700 bits.

// Optimization:  Don't do the compare at the end of mod_simple_192.  Find a completely faster way to do this!  
      mod_simple_192(&a, tmp192, f, ff);		// Adjustment.  The code above may produce an a that is too large by up to 13 times f.
						        // The adjustment should be perfect, so we now have 188 bits.
    }

#if 0
    if(cmp_ge_192(a,f))
    {
      printf("EEEEEK, final a is >= f\n");
    }
if (blockIdx.x == 12 && threadIdx.x == 4){
mul_192_384_no_low6(&tmp192,u,f);
printf ("bits_in_f: %d\r\n", 352 + (bits_max - 1) - 191);
printf ("    f: %08X%08X%08X%08X%08X%08X\r\n", f.d5, f.d4, f.d3, f.d2, f.d1, f.d0);
printf ("u    : %X %X %X %X %X %X\r\n", u.d5, u.d4, u.d3, u.d2, u.d1, u.d0);
printf ("u * f: %X %X %X %X %X %X\r\n", tmp192.d5, tmp192.d4, tmp192.d3, tmp192.d2, tmp192.d1, tmp192.d0);
printf ("    a: %08X%08X%08X%08X%08X%08X\r\n", a.d5, a.d4, a.d3, a.d2, a.d1, a.d0);
}
#endif

/* check if we found a factor and write the factor to RES[] */

    if(a.d0 == 2 && (a.d5 | a.d4 | a.d3 | a.d2 | a.d1) == 0)
    {
      int index=atomicInc(&RES[0],10000);
      if(index<10)				/* limit to 10 factors per class */
      {
        RES[index*6 + 1]=f.d5;
	RES[index*6 + 2]=f.d4;
	RES[index*6 + 3]=0xFFFFFFFF;
	RES[index*6 + 4]=0xFFFFFFFF;
	RES[index*6 + 5]=f.d1;
	RES[index*6 + 6]=f.d0;
      }
    }
  }

/* finally write occasional result for validation by C code */

  if(blockIdx.x == 0 && threadIdx.x == 0)
  {
    RES[84]=f.d5;
    RES[85]=f.d4;
    RES[86]=0xFFFFFFFF;
    RES[87]=0xFFFFFFFF;
    RES[88]=f.d1;
    RES[89]=f.d0;
    RES[94]=a.d5;
    RES[95]=a.d4;
    RES[96]=a.d3;
    RES[97]=a.d2;
    RES[98]=a.d1;
    RES[99]=a.d0;
  }
}
